<template>
    <div id="testcustomlayoutpanelgridexpviewgridexpbar" class="app-grid-exp-bar">
        <div class='grid-exp-bar-header'>
            <div class="grid-exp-bar-title">
                <icon type='ios-home-outline'/>{{ $t('app.gridBar.title') }}
            </div>
        </div>
        <div class="exp-bar-action-container">
        </div>
            <div class='grid-exp-bar-content'>
                <view_gridexpbar_grid 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context"
    :viewCtx="viewCtx"
    :isSingleSelect="isSingleSelect"
    :showBusyIndicator="true"
    updateAction=""
    removeAction="Remove"
    loaddraftAction=""
    loadAction=""
    createAction=""
    fetchAction="FetchDefault"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="gridexpbar_grid"  
    ref='gridexpbar_grid' 
    @selectionchange="gridexpbar_grid_selectionchange($event)"  
    @load="gridexpbar_grid_load($event)"  
    @closeview="closeView($event)">
</view_gridexpbar_grid>
            </div>
    </div>
</template>


<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZOrderEntityService from '@/service/ibizorder/ibizorder-service';
import TestCustomLayoutPanelGridExpViewgridexpbarService from './test-custom-layout-panel-grid-exp-viewgridexpbar-gridexpbar-service';
import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';
import CodeListService from "@/codelist/codelist-service";


@Component({
    components: {
      
    }
})
export default class TestCustomLayoutPanelGridExpViewgridexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public viewCtx!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public getControlType(): string {
        return 'GRIDEXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {TestCustomLayoutPanelGridExpViewgridexpbarService}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public service: TestCustomLayoutPanelGridExpViewgridexpbarService = new TestCustomLayoutPanelGridExpViewgridexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public appEntityService: IBIZOrderEntityService = new IBIZOrderEntityService({ $store: this.$store });

    /**
     * gridexpbar_grid 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public gridexpbar_grid_selectionchange($event: any, $event2?: any) {
        this.gridexpbar_selectionchange($event, 'gridexpbar_grid', $event2);
    }

    /**
     * gridexpbar_grid 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public gridexpbar_grid_load($event: any, $event2?: any) {
        this.gridexpbar_load($event, 'gridexpbar_grid', $event2);
    }
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }





    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 视图唯一标识
     *
     * @type {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public isSingleSelect:boolean = true;


    /**
     * 可搜索字段名称
     * 
     * 
     * @type {(string)}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public placeholder = "订单名称";

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public searchText: string = "";


    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public navViewName: string = "ibizorder-detail-grid-view9";

    /**
     * 导航过滤项
     *
     * @type {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public navFilter: string = "";

    /**
     * 导航关系
     *
     * @type {string}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public navPSDer: string = "n_ibizorderid_eq";
    
    /**
     * 导航上下文参数
     *
     * @type {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public navigateContext:any =null;

    /**
     * 导航视图参数
     *
     * @type {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public navigateParams:any = null; 

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof MOBILEENTITY3Canlen
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public created() {
        this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'gridexpbar_grid', action: action, data: data });
            });
        } 
    }

    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public afterMounted() { }

    /**
     * vue 生命周期
     *
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
    * 执行搜索
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public onSearch($event:any) {
        let grid:any = this.$refs.gridexpbar_grid;
        grid.load({ query: this.searchText });
        
    }

    /**
    * 刷新
    *
    * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
    */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.gridexpbar_grid) {
            refs.gridexpbar_grid.refresh();
        }
    }

    /**
     * gridexpbar的选中数据事件
     * 
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public gridexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        const tempContext: any = {};
        const tempViewParam: any = {};
        if (args.length === 0) {
            this.calcToolbarItemState(true);
            return ;
        }
        const arg: any = args[0];
        if (this.context) {
            Object.assign(tempContext, JSON.parse(JSON.stringify(this.context)));
        }
        Object.assign(tempContext, { 'ibizorder': arg['ibizorder']});
        Object.assign(tempContext, { srfparentdename: 'IBIZOrder', srfparentkey:arg['ibizorder']});
        if (this.navFilter && !Object.is(this.navFilter, "")) {
            Object.assign(tempViewParam, { [this.navFilter]: arg['ibizorder']});
        }
        if (this.navPSDer && !Object.is(this.navPSDer,"")) {
            Object.assign(tempViewParam, { [this.navPSDer]: arg['ibizorder']});
        }
        if (this.navigateContext && Object.keys(this.navigateContext).length > 0) {
            let _context:any = this.$util.computedNavData(arg, tempContext, tempViewParam, this.navigateContext);
            Object.assign(tempContext, _context);
        }
        if (this.navigateParams && Object.keys(this.navigateParams).length > 0) {
            let _params:any = this.$util.computedNavData(arg, tempContext, tempViewParam, this.navigateParams);
            Object.assign(tempViewParam, _params);
        }
        const navItem: any = {
            navView: this.navViewName,
            data: args,
            srfnavdata: {
                context: tempContext,
                viewparams: tempViewParam
            }
        }
        this.calcToolbarItemState(false);
        this.$emit('selectionchange', navItem);
    }

    /**
     * gridexpbar的load完成事件
     * 
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public gridexpbar_load(args:any, tag?: string, $event2?: any){
        this.calcToolbarItemState(true);
        this.$emit('load',args);
    }
    
    /**
     * 设置导航区工具栏禁用状态
     *
     * @param {boolean} state
     * @return {*} 
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public calcToolbarItemState(state: boolean) {
        let _this: any = this;
        const models:any = _this.testcustomlayoutpanelgridexpviewgridexpbar_toolbarModels;
        if (models) {
            for (const key in models) {
                if (!models.hasOwnProperty(key)) {
                    return;
                }
                const _item = models[key];
                if (_item.uiaction && (Object.is(_item.uiaction.target, 'SINGLEKEY') || Object.is(_item.uiaction.target, 'MULTIKEY'))) {
                    _item.disabled = state;
                }
                _item.visabled = true;
                if (_item.noprivdisplaymode && _item.noprivdisplaymode === 6) {
                    _item.visabled = false;
                }
            }
            this.calcNavigationToolbarState();
        }
    }   

    /**
     * 计算导航工具栏权限状态
     * 
     * @memberof TestCustomLayoutPanelGridExpViewgridexpbarBase
     */
    public calcNavigationToolbarState(){
        let _this: any = this;
        // 界面行为
        if(_this.testcustomlayoutpanelgridexpviewgridexpbar_toolbarModels){
            const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
            ViewTool.calcActionItemAuthState({},_this.testcustomlayoutpanelgridexpviewgridexpbar_toolbarModels,curUIService);
        }
    }
}
</script>

<style lang='less'>
@import './test-custom-layout-panel-grid-exp-viewgridexpbar-gridexpbar.less';
</style>